/*
**  ramvars.c
**  (c)Huron Net Works, Inc., 2005
**
**  RAM Data Definitions
**
**	7/1/05	-- Original
**
**  TABS 5, 9
*/


#ifndef  GLOBAL
#include	"hardware.h"
#define	GLOBAL
#define	I(x) = x
#endif

/*
**	Global bdata
*/
GLOBAL	bdata	unsigned char	g_Flags0 ;			/* Operational Flags 0	*/
GLOBAL	bdata	unsigned char	g_Flags1 ;			/* Operational Flags 1	*/
GLOBAL	bdata	unsigned char	g_stFlags ;			/* Selftest Flags		*/
GLOBAL	bdata	unsigned char	g_spFlags ;			/* Serial Port Flags	*/
GLOBAL	bdata	unsigned char	g_gsmFlags ;		/* GSM UART Flags		*/
GLOBAL	bdata	unsigned char	g_gpsFlags ;		/* GPS UART Flags		*/
GLOBAL	bdata	unsigned char	g_bits ;
/*
**	Global data
*/
GLOBAL	data	unsigned int	g_Tick ;
GLOBAL	data	unsigned int	g_flashTime ;
GLOBAL	data	unsigned int	g_intervalTimer ;
GLOBAL	data	unsigned int	g_oneSecond ;
GLOBAL	data	unsigned int	g_linkTime ;
GLOBAL	data	unsigned int	g_ringTime ;
GLOBAL	data	unsigned int	PA_Timer ;
GLOBAL	data	unsigned int	PA_Repeat ;
GLOBAL	data	unsigned int	g_repeat ;

GLOBAL	data	unsigned char	g_keyTime ;
GLOBAL	data	unsigned char	g_waitTime ;
GLOBAL	data	unsigned char	g_debounce ;
GLOBAL	data	unsigned char	g_chirpTime ;
GLOBAL	data	unsigned char	gsm_periodic ;
GLOBAL	data	unsigned char	gps_Timer ;

GLOBAL	data	unsigned char	g_state ;
GLOBAL	data	unsigned char	g_key ;
GLOBAL	data	unsigned char	bkey[3] ;
GLOBAL	data	unsigned char	g_symbol ;

GLOBAL	data	unsigned char	gsm_state ;
GLOBAL	data	unsigned char	gsm_service ;
GLOBAL	data	unsigned char	gsm_status ;
GLOBAL	data	unsigned char	nCall ;

GLOBAL	data	unsigned char	g_arg1 ;	


GLOBAL	data	unsigned char	g_clock[5] ;
GLOBAL	data	unsigned char	SPI_IN[2] ;
GLOBAL	data	unsigned char	op_state ;		/* Operational state			*/
GLOBAL	data	unsigned char	led_state ;		/* Bi-color LED state			*/
GLOBAL	data	unsigned char	led_input ;		/* Bi-color LED input variable	*/

GLOBAL	data	unsigned char	g_parameter ;	/* Used to keep track of the parameter on the display				*/

GLOBAL	xdata	unsigned char	p_QuickConfig ;			/* Enumerated Value [1..5]	*/
GLOBAL	xdata	unsigned char	p_PanicAlarmTime ;		/* Enumerated Value [1..5]	*/
GLOBAL	xdata	unsigned char	p_PanicAlarmRepeat ;	/* Enumerated Value [1..6]	*/
GLOBAL	xdata	unsigned char	p_PanicAlarmSound ;		/* Enumerated Value [1..3]	*/
GLOBAL	xdata	unsigned char	p_911CallDelay ;		/* Enumerated Value [1..6]	*/
GLOBAL	xdata	unsigned char	p_SpeakerVolume ;		/* Enumerated Value [1..4]	*/
GLOBAL	xdata	unsigned char	p_GPSReport ;			/* Enumerated Value [1..6]	*/
GLOBAL	xdata	unsigned char	p_GPSPower ;			/* Enumerated Value [1..3]	*/
GLOBAL	xdata	unsigned char	p_SMSService ;			/* Enumerated Value [1..3]	*/
GLOBAL	xdata	unsigned char	p_SMSAlert ;			/* Enumerated Value [1..4]	*/
GLOBAL	xdata	unsigned char	p_ClockDisplay ;		/* Enumerated Value [1..4]	*/
GLOBAL	xdata	unsigned char	p_ClockTimeZone ;		/* Enumerated Value [1..26]	*/
GLOBAL	xdata	unsigned char	p_SMSQuickText ;		/* Enumerated Value [1..13]	*/

/*
**	sp_RxBuffer is a circular queue for received characters from the 
**	onboard UART.  It is 16 elements long.
*/
#define	SP_RX_SIZE	16
GLOBAL	idata	unsigned char	sp_RxBuffer[SP_RX_SIZE] ;
GLOBAL	data	unsigned char	sp_RxPut ;	/* Serial Port Receive Put Index						*/
GLOBAL	data	unsigned char	sp_RxGet ;	/* Serial Port Receive Get Index						*/
GLOBAL	data	unsigned char	sp_nRx ;	/* Serial Port Receive Number of characters	in queue	*/

/*
**	sp_TxBuffer is a circular queue for characters to be transmitted by
**	the onboard UART.  It is 256 elements long.
*/
GLOBAL xdata	unsigned char	sp_TxBuffer[256] ;
GLOBAL data		unsigned char	sp_TxPut ;	/* Serial Port Transmit Put Index						*/
GLOBAL data		unsigned char	sp_TxGet ;	/* Serial Port Transmit Get Index						*/
GLOBAL data		unsigned char	sp_nTx ;	/* Serial Port Transmit Number of characters in queue	*/

/*
**	gps_RxBuffer is a circular queue for received characters from the
**	GPS UART, a Maxim 3100.  It is 256 characters long
*/
GLOBAL	xdata	unsigned char	gps_RxBuffer[256] ;
GLOBAL	data	unsigned char	gps_RxPut ;
GLOBAL	data	unsigned char	gps_RxGet ;
GLOBAL	data	unsigned char	gps_nRx ;

/*
**	gps_TxBuffer is a circular queue for characters to be transmitted by
**	the GPS UART, a Maxim 3100.  It is 256 characters long
*/
#define	GPS_TX_SIZE		128
GLOBAL	xdata	unsigned char	gps_TxBuffer[GPS_TX_SIZE] ;
GLOBAL	data	unsigned char	gps_TxPut ;
GLOBAL	data	unsigned char	gps_TxGet ;
GLOBAL	data	unsigned char	gps_nTx ;

/*
**	gsm_RxBuffer is a circular queue for received characters from the
**	GSM UART, a Maxim 3100.  It is 256 characters long
*/
GLOBAL	xdata	unsigned char	gsm_RxBuffer[256] ;
GLOBAL	data	unsigned char	gsm_RxPut ;
GLOBAL	data	unsigned char	gsm_RxGet ;
GLOBAL	data	unsigned char	gsm_nRx ;

/*
**	gsm_TxBuffer is a circular queue for characters to be transmitted by
**	the GSM UART, a Maxim 3100.  It is 256 characters long
*/
GLOBAL	xdata	unsigned char	gsm_TxBuffer[256] ;
GLOBAL	data	unsigned char	gsm_TxPut ;
GLOBAL	data	unsigned char	gsm_TxGet ;
GLOBAL	data	unsigned char	gsm_nTx ;


GLOBAL	data	unsigned char	gsm_ATRetry ;
GLOBAL	data	unsigned int	gsm_time ;
GLOBAL	xdata	unsigned char	gsmResponse[220] ;
GLOBAL	data	unsigned char	gsm_x ;
GLOBAL	data	unsigned char	gsm_newlines ;
GLOBAL	data	unsigned char	gsm_maxtoken ;
GLOBAL	data	unsigned char	gsm_token[10] ;
		
GLOBAL	data	unsigned char	mx ;

GLOBAL	xdata	unsigned char	GPRMC[80] ;				/* GPRMC Message	*/
GLOBAL	idata	unsigned char	g_MessageChecksum ;
GLOBAL	idata	unsigned char	g_ComputedChecksum ;
GLOBAL	idata	unsigned char	g_gpsStatus ;
GLOBAL	idata	unsigned char	g_latitude[10] ;		/* ddmm.mmmm	*/
GLOBAL	idata	unsigned char	g_latitudeIndicator ;
GLOBAL	idata	unsigned char	g_longitude[11] ;		/* dddmm.mmmm	*/
GLOBAL	idata	unsigned char	g_longitudeIndicator ;

GLOBAL	idata	unsigned char	g_savedlatitude[10] ;
GLOBAL	idata	unsigned char	g_savedlatitudeIndicator ;
GLOBAL	idata	unsigned char	g_savedlongitude[11] ;
GLOBAL	idata	unsigned char	g_savedlongitudeIndicator ;

GLOBAL	idata	unsigned char	gps_Clock[11] ;
GLOBAL	idata	unsigned char	gps_hours ;

GLOBAL	xdata	unsigned char	sms_GPRMC[80] ;
GLOBAL	xdata	unsigned char	gsm_Clock[18] ;			/* GSM Modem Clock String	*/

GLOBAL	data	unsigned char	g_CSQ ;		/* Signal Quality extracted from at+csq command		*/
GLOBAL	data	unsigned char	g_SBC ;		/* Battery Capacity extracted from at^sbc? command	*/
GLOBAL	data	unsigned int	g_seconds ;	/* Count seconds for periodic tasks					*/

/*
**	Non-Volatile Storage
**	Factory Initialization and As Shipped Block
**
**	Non-volitile addresses are encoded as follows:
**	NVL_	Non-volitile Lock Byte
**	NVID_	Changeable in RAM, by Services in Factory Test Object
**			Written from RAM by a Factory Lock Service of the Factory Test Object
**	NVAS_	Changeable in RAM, by SET_ATTRIBUTE_SINGLE to particular object
**			Written from RAM by a Factory Lock Service of the Factory Test Object
**	NVS_	Changeable in RAM, by SET_ATTRIBUTE_SINGLE to particular object
**			Restored to NVAS_ value on a RESET 1 OR
**			Update in Background in main
**
*/
#define NVL_factoryLock0		0     	/* Serial EEPROM data addresses */

/*
**	NVAS_
**	records As Shipped Parameters
*/

#define	NVL_factoryLock1		63

#define	NVL_configLock0			80

#	define	NVL_dnetLock0		81
#	define	NVL_dnetLock1		88
#	define	NVL_digitalLock0	96
#	define	NVL_digitalLock1	103
#	define	NVL_vspLock0		122
#	define	NVL_vspLock1		126

#define	NVL_configLock1			127
