/*
**  cgen.c
**  (c)Huron Net Works, Inc., 2005
**
**  Character Generator Data Definitions
**	5x7 ASCII Printable Characters
**
**	7/7/05	-- 	Original
**	9/13/05	--	Add battery and antenna symbols
**	9/15/05	--	Add lower case letters
**	9/16/05	--	Correct lower case t, v, and z
**
**  TABS 5, 9
*/

const unsigned char g_cgen[][8] =
{
/*	Control Characters	{0x00 thru 0x1F}									*/
	"\x00\xFF\x81\x81\x81\xFF",		/*	00	NUL	-- Box						*/
	"\x01\x38\x44\x44\x38\x44",		/*	01	SOH -- Greek alpha				*/
	"\x02\xFE\x01\x29\x2E\x10",		/*	02	STX -- Greek beta				*/
	"\x03\xFE\x82\x83\x82\xFE",		/*	03	ETX -- Battery 00%,  0 rows		*/
	"\x04\xFE\xC2\xC3\xC2\xFE",		/*	04	EOT -- Battery 20%,  1 row		*/
	"\x05\xFE\xE2\xE3\xE2\xFE",		/*	05	ENQ	-- Battery 40%,  2 rows		*/
	"\x06\xFE\xF2\xF3\xF2\xFE",		/*	06	ACK -- Battery 60%,  3 rows		*/
	"\x07\xFE\xFA\xFB\xFA\xFE",		/*	07	BEL	-- Battery 80%,  4 rows		*/
	"\x08\xFE\xFE\xFF\xFE\xFE",		/*	08	BS  -- Battery 100%, 5 rows		*/
	"\x09\x30\x4A\x4D\x49\x30",		/*	09	HT	-- Greek Delta				*/
	"\n\x10\x20\x7F\x20\x10",		/*	0A	NL	-- Down Arrow				*/
	"\x0B\x1E\x04\x04\x38\x40",		/*	0B	VT	-- Greek eta				*/
	"\x0C\x3E\x49\x49\x49\x3E",		/*	0C	FF	-- Greek theta				*/
	"\r\x08\x1C\x2A\x08\x0C",		/*	0D	CR								*/
	"\x0E\x62\x14\x08\x10\x60",		/*	0E	SO	-- Greek lambda				*/
	"\x0F\x80\x7C\x20\x20\x1C",		/*	0F	SI	-- Greek mu					*/
	"\x10\x03\x06\xFC\x06\x03",		/*	10	DLE -- Antenna					*/
	"\x11\xC0\x00\x00\x00\x00",		/*	11	DC1 -- Signal Strength - 1 Bar	*/
	"\x12\xC0\x00\xE0\x00\x00",		/*	12	DC2 -- Signal Strength - 2 Bars	*/
	"\x13\xC0\x00\xE0\x00\xF0",		/*	13	DC3 -- Signal Strength - 3 Bars	*/
	"\x14\xF8\x00\x00\x00\x00",		/*	14	DC4 -- Signal Strength - 4 Bars	*/
	"\x15\xF8\x00\xFC\x00\x00",		/*	15	NAK -- Signal Strength - 5 Bars	*/
	"\x16\xF8\x00\xFC\x00\xFE",		/*	16	SYN -- Signal Strength - 6 Bars	*/
	"\x17\x48\x7E\x49\x41\x42",		/*	17	ETB -- Pounds Sterling			*/
	"\x18\x01\x12\x7C\x12\x01",		/*	18	CAN -- Yen						*/
	"\x19\x41\x63\x55\x49\x41",		/*	19	EM	-- Greek Sigma				*/
	"\x1A\x08\x08\x2A\x1C\x08",		/*	1A	SUB -- Right Arrow				*/
	"\x1B\x04\x02\x7F\x02\x04",		/*	1B	ESC -- Up Arrow					*/
	"\x1C\x08\x1C\x2A\x08\x08",		/*	1C	FS  -- Left Arrow				*/
	"\x1D\x20\x7E\x02\x02\x02",		/*	1D	GS	-- SQRT						*/
	"\x1E\x18\x24\x7E\x24\x18",		/*	1E	RS	-- Greek phi				*/
	"\x1F\x08\x7C\x04\x7C\x02",		/*	1F	US	-- Greek pi					*/
	
/*	Special Characters	{0x20 thru 0x2F}			*/
	" \x00\x00\x00\x00\x00",		/*	20	Space	*/
	"!\x00\x00\x5F\x00\x00",		/*	21	!		*/
	"\"\x00\x03\x00\x03\x00",		/*	22	"		*/
	"#\x14\x7F\x14\x7F\x14",		/*	23	#		*/
	"$\x24\x2A\x7F\x2A\x12",		/*	24	$		*/
	"%\x63\x13\x08\x64\x63",		/*	25	%		*/
	"&\x30\x4A\x55\x22\x50",		/*	26	&		*/
	"\'\x00\x0B\x07\x00\x00",		/*	27	'		*/
	"(\x1C\x22\x41\x00\x00",		/*	28	(		*/
	")\x00\x00\x41\x22\x1C",		/*	29	)		*/
	"*\x14\x08\x3E\x08\x14",		/*	2A	*		*/
	"+\x08\x08\x3E\x08\x08",		/*	2B	+		*/
	",\x00\xB0\x70\x00\x00",		/*	2C	,		*/
	"-\x08\x08\x08\x08\x08",		/*	2D	-		*/
	".\x00\x30\x30\x00\x00",		/*	2E	.		*/
	"/\x60\x10\x08\x04\x03",		/*	2F	/		*/

/*	Numbers {0x30 thru 0x39}						*/
	"0\x3E\x51\x49\x45\x3E",		/*	30	0		*/
	"1\x00\x42\x7F\x40\x00",		/*	31	1		*/
	"2\x62\x51\x49\x49\x46",		/*	32	2		*/
	"3\x21\x41\x45\x4B\x31",		/*	33	3		*/
	"4\x18\x14\x12\x7F\x10",		/*	34	4		*/
	"5\x27\x45\x45\x45\x39",		/*	35	5		*/
	"6\x3C\x4A\x49\x49\x30",		/*	36	6		*/
	"7\x03\x01\x71\x09\x07",		/*	37	7		*/
	"8\x36\x49\x49\x49\x36",		/*	38	8		*/
	"9\x06\x49\x49\x29\x1E",		/*	39	9		*/
	
/*	Special Characters	{0x3A thru 0x40}			*/
	":\x00\x36\x36\x00\x00",		/*	3A	:		*/
	";\x00\x56\x36\x00\x00",		/*	3B	;		*/
	"<\x08\x14\x22\x41\x00",		/*	3C	<		*/
	"=\x14\x14\x14\x14\x14",		/*	3D	=		*/
	">\x00\x41\x22\x14\x08",		/*	3E	>		*/
	"?\x02\x01\x51\x09\x06",		/*	3F	?		*/
	"@\x32\x49\x79\x41\x3E",		/*	40	@		*/

/*	Upper Case Alphabet {0x41 thru 0x5A}			*/
	"A\x7C\x12\x11\x12\x7C",		/*	41	A		*/
	"B\x7F\x49\x49\x49\x36",		/*	42	B		*/
	"C\x3E\x41\x41\x41\x22",		/*	43	C		*/
	"D\x7F\x41\x41\x41\x3E",		/*	44	D		*/
	"E\x7F\x49\x49\x41\x41",		/*	45	E		*/
	"F\x7F\x09\x09\x01\x01",		/*	46	F		*/
	"G\x3E\x41\x41\x51\x32",		/*	47	G		*/
	"H\x7F\x08\x08\x08\x7F",		/*	48	H		*/
	"I\x00\x41\x7F\x41\x00",		/*	49	I		*/
	"J\x20\x40\x40\x40\x3F",		/*	4A	J		*/
	"K\x7F\x08\x14\x22\x41",		/*	4B	K		*/
	"L\x7F\x40\x40\x40\x40",		/*	4C	L		*/
	"M\x7F\x02\x0C\x02\x7F",		/*	4D	M		*/
	"N\x7F\x02\x1C\x20\x7F",		/*	4E	N		*/
	"O\x3E\x41\x41\x41\x3E",		/*	4F	O		*/
	"P\x7F\x09\x09\x09\x06",		/*	50	P		*/
	"Q\x3E\x41\x51\x21\x5E",		/*	51	Q		*/
	"R\x7F\x09\x09\x19\x66",		/*	52	R		*/
	"S\x26\x49\x49\x49\x32",		/*	53	S		*/
	"T\x01\x01\x7F\x01\x01",		/*	54	T		*/
	"U\x3F\x40\x40\x40\x3F",		/*	55	U		*/
	"V\x1F\x20\x40\x20\x1F",		/*	56	V		*/
	"W\x3F\x40\x30\x40\x3F",		/*	57	W		*/
	"X\x63\x14\x08\x14\x63",		/*	58	X		*/
	"Y\x03\x04\x78\x04\x03",		/*	59	Y		*/
	"Z\x61\x51\x49\x45\x43",		/*	5A	Z		*/
	
/*	Special Characters	{0x5B thru 0x60}			*/	
	"[\x7F\x41\x41\x00\x00",		/*	5B	[		*/
	"\\\x03\x04\x08\x10\x60",		/*	5C	\		*/
	"]\x00\x00\x41\x41\x7F",		/*	5D	]		*/
	"^\x04\x02\x01\x02\x04",		/*	5E	^		*/
	"_\x80\x80\x80\x80\x80",		/*	5F	_		*/
	"`\x00\x07\x0B\x00\x00",		/*	60	`		*/
	
/*	Lower Case Alphabet								*/
	"a\x38\x44\x44\x3C\x40",		/*	61	a		*/
	"b\x7F\x48\x44\x44\x38",		/*	62	b		*/
	"c\x38\x44\x44\x44\x20",		/*	63	c		*/
	"d\x38\x44\x44\x48\x7F",		/*	64	d		*/
	"e\x38\x54\x54\x54\x08",		/*	65	e		*/
	"f\x08\x7E\x09\x02\x00",		/*	66	f		*/
	"g\x18\x24\xA4\xA4\x78",		/*	67	g		*/
	"h\x7F\x08\x04\x04\x78",		/*	68	h		*/
	"i\x00\x44\x7D\x40\x00",		/*	69	i		*/
	"j\x40\x80\x84\x7D\x00",		/*	6A	j		*/
	"k\x00\x7F\x10\x28\x44",		/*	6B	k		*/
	"l\x00\x41\x7F\x40\x00",		/*	6C	l		*/
	"m\x78\x04\x18\x04\x78",		/*	6D	m		*/
	"n\x7C\x08\x04\x04\x78",		/*	6E	n		*/
	"o\x38\x44\x44\x44\x38",		/*	6F	o		*/
	"p\xFC\x14\x24\x24\x18",		/*	70	p		*/
	"q\x18\x24\x14\xFC\x80",		/*	71	q		*/
	"r\x00\x7C\x08\x04\x04",		/*	72	r		*/
	"s\x48\x54\x54\x54\x20",		/*	73	s		*/
	"t\x04\x3E\x44\x20\x00",		/*	74	t		*/
	"u\x3C\x40\x40\x20\x7C",		/*	75	u		*/
	"v\x1C\x20\x40\x20\x1C",		/*	76	v		*/
	"w\x3C\x40\x20\x40\x3C",		/*	77	w		*/
	"x\x44\x28\x10\x28\x44",		/*	78	x		*/
	"y\x04\x88\x70\x08\x04",		/*	79	y		*/
	"z\x44\x64\x54\x4C\x44",		/*	7A	z		*/
	"{\x08\x36\x41\x00\x00",		/*	7B	{		*/
	"|\x00\x00\x77\x00\x00",		/*	7C	|		*/
	"}\x00\x00\x41\x36\x08",		/*	7D	}		*/
	"~\x08\x04\x08\x10\x08",		/*	7E	~		*/
	"\x7F\x08\x1C\x3E\x7F\x00"		/*	7F	DEL		*/
} ;
