/*
**  gsm.c
**  (c)Huron Net Works, Inc., 2005
**
**  9/12/05	--	Initial
**
**
**  TABS 5, 9
*/
#include	"hardware.h"
#include	"externs.h"

/* 	Configure for 9600 baud, 8N1, and Tx and Rx Interrupts	*/
/*	The following expression should yield 0xCC0B			*/

#define	GSM_UART_CONFIGURATION	\
(		SPI_UART_WRITE_CONFIGURATION	\
	+	SPI_UART_TM_BAR	\
	+	SPI_UART_RM_BAR	\
	+	BR009P6	\
)

const unsigned char gsm_ClockInit[] = "05/11/14,"__TIME__ ;
void	gsm_SetClock(void)
{
	mx = 0 ;
	while(gsm_ClockInit[mx] != 0)
	{
		gsm_Clock[mx] = gsm_ClockInit[mx] ;
		++mx ;
	}
}

const unsigned char	atr[] = "at\r" ;
void	gsm_sendATR(void)
{	/* For short commands send them immediately	*/
	gsm_TxEnQueue('a') ;
	gsm_TxEnQueue('t') ;
	gsm_TxEnQueue('\r') ;
	EC = 0 ; g_linkTime = 2000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}

/*	The timeout interval is determined empirically
**	by measuring the response time, multiplying by four
**	and rounding up the nearest multiple of 25
**	ResponseMax(at+cmgf=1) = 95 msec.
**	4 * 95msec. = 380 msec ~= 400 msec.
*/ 
const unsigned char	at_cmgf[] = "at+cmgf=1\r" ;
void	gsm_sendATPCMGF(void)
{
	mx = 0 ;
	while(at_cmgf[mx] != '\0')	gsm_TxEnQueue(at_cmgf[mx++]) ;
	EC = 0 ; g_linkTime = 400 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}

#if	defined(__NEED_ATPCNMI__)
/*	The timeout interval is determined empirically
**	by measuring the response time, multiplying by four
**	and rounding up the nearest multiple of 25
**	ResponseMax(at+cnmi=1,1) = 98 msec.
**	4 * 98msec. = 392 msec ~= 400 msec.
*/ 
const unsigned char	at_cnmi[] = "at+cnmi=1,1\r" ;
void	gsm_sendATPCNMI(void)
{
 	mx = 0 ;
	while(at_cnmi[mx] != '\0')	gsm_TxEnQueue(at_cnmi[mx++]) ;
	EC = 0 ; g_linkTime = 400 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}
#endif

/*
**	at+cmee=1 cuases errors to be displayed numerically
*/
const unsigned char at_cmee[] = "at+cmee=1\r" ;
void	gsm_sendATPCMEE(void)
{
	mx = 0 ;
	while(at_cmee[mx] != '\0')	gsm_TxEnQueue(at_cmee[mx++]) ;
	EC = 0 ; g_linkTime = 400 ;
	EC = 1 ;
}

#if		defined(__MATTS_PHONE__)
/*	This number is Matt's cell phone	*/
const unsigned char at_cmgs[] = "at+cmgs=7342558653\r" ;
#elif	defined(__MARYS_PHONE__)
/*	This number is Mary's cell phone	*/
const unsigned char at_cmgs[] = "at+cmgs=7349048434\r" ;
#elif	defined(__OUR_CINGULAR_PHONE_1__)
/*	This is our original cingular cell phone	*/
const unsigned char at_cmgs[] = "at+cmgs=3581234\r" ;
#elif	defined(__OUR_CINGULAR_PHONE_2__)
/*	This is our alternate cingular cell phone	*/
const unsigned char at_cmgs[] = "at+cmgs=3556056\r" ;
#elif	defined(__OUR_T_MOBILE_PHONE_1__)
/*	This is our original T-Mobile cell Phone	*/
const unsigned char at_cmgs[] = "at+cmgs=2622365\r" ;
#elif	defined(__OUR_T_MOBILE_PHONE_2__)
const unsigned char at_cmgs[] = "at+cmgs=8464231\r" ;
#elif	defined(__JAMIES_PHONE__)
/*	This number is Jamie's phone		*/
const unsigned char	at_cmgs[] = "at+cmgs=6049741\r" ;
#elif	defined(__USE_SHORT_CODE__)
/*	This is the short code to get to the beepit website	*/
const unsigned char at_cmgs[] = "at+cmgs=47647\r" ;
#else
#error	No SMS Phone Number or short code selected
#endif

void	gsm_sendATPCMGS(void)
{
	mx = 0 ;
	while(at_cmgs[mx] != '\0')	gsm_TxEnQueue(at_cmgs[mx++]) ;
	EC = 0 ; g_linkTime = 4000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}

#define	SST(s,b)	while( s [mx] != 0 ) b (s [mx++] )

extern const unsigned char ds_13_2_1[17]  ;
extern const unsigned char ds_13_2_2[17]  ;
extern const unsigned char ds_13_2_3[17]  ;
extern const unsigned char ds_13_2_4[17]  ;
extern const unsigned char ds_13_2_5[17]  ;
extern const unsigned char ds_13_2_6[17]  ;
extern const unsigned char ds_13_2_7[17]  ;
extern const unsigned char ds_13_2_8[17]  ;
extern const unsigned char ds_13_2_9[17]  ;
extern const unsigned char ds_13_2_10[17] ;
extern const unsigned char ds_13_2_11[17] ;
extern const unsigned char ds_13_2_12[17] ;
extern const unsigned char ds_13_2_13[17] ;
extern const unsigned char ds_13_2_14[17] ;
extern const unsigned char ds_13_2_15[17] ;
extern const unsigned char ds_13_2_16[17] ;

const unsigned char	sms_text[]		= "nmsi1 beepit 890141011003462661830000000001" ;
const unsigned char sms_emergency[]	= "911 Emergency!! " ;
const unsigned char sms_pad[]		= "================" ;

void	gsm_sendSMSTEXT(void)
{
	mx = 0 ;
	while(sms_text[mx] != '\0')		{ gsm_TxEnQueue(sms_text[mx++]) ; }

	mx = 0 ;
	switch(p_SMSQuickText)
	{
		default :	p_SMSQuickText = 1 ;
		case 1  :	SST(ds_13_2_1,  gsm_TxEnQueue) ; break ;
		case 2  :	SST(ds_13_2_2,	gsm_TxEnQueue) ; break ;
		case 3  :	SST(ds_13_2_3,  gsm_TxEnQueue) ; break ;
		case 4  :	SST(ds_13_2_4,  gsm_TxEnQueue) ; break ;
		case 5  :	SST(ds_13_2_5,  gsm_TxEnQueue) ; break ;
		case 6  :	SST(ds_13_2_6,  gsm_TxEnQueue) ; break ;
		case 7  :	SST(ds_13_2_7,  gsm_TxEnQueue) ; break ;
		case 8  :	SST(ds_13_2_8,  gsm_TxEnQueue) ; break ;
		case 9  :	SST(ds_13_2_9,  gsm_TxEnQueue) ; break ;
		case 10 :	SST(ds_13_2_10, gsm_TxEnQueue) ; break ;
		case 11 :	SST(ds_13_2_11, gsm_TxEnQueue) ; break ;
		case 12 :	SST(ds_13_2_12, gsm_TxEnQueue) ; break ;
		case 13 :	SST(ds_13_2_13, gsm_TxEnQueue) ; break ;
		case 14 :	SST(ds_13_2_14, gsm_TxEnQueue) ; break ;
		case 15 :	SST(ds_13_2_15, gsm_TxEnQueue) ; break ;
		case 16 :	SST(ds_13_2_16, gsm_TxEnQueue) ; break ;
	}
	mx = 0 ;
	SST(sms_pad, gsm_TxEnQueue) ;
	gsm_TxEnQueue('#') ;
	mx = 1 ;
	while(sms_GPRMC[mx] != '\0')	{ gsm_TxEnQueue(sms_GPRMC[mx++]) ; } 
	gsm_TxEnQueue('\x1A') ;
	EC = 0 ; g_linkTime = 20000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}

void	gsm_sendEMERGENCY(void)
{
	mx = 0 ;
	while(sms_text[mx] != '\0')		{ gsm_TxEnQueue(sms_text[mx++]) ; }
	mx = 0 ;
	SST(sms_emergency, gsm_TxEnQueue) ;
	mx = 0 ;
	SST(sms_pad, gsm_TxEnQueue) ;
	gsm_TxEnQueue('#') ;
	mx = 1 ;
	while(sms_GPRMC[mx] != '\0')	{ gsm_TxEnQueue(sms_GPRMC[mx++]) ; } 
	gsm_TxEnQueue('\x1A') ;
	EC = 0 ; g_linkTime = 20000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}	

#define	__NEED_SHUTDOWN__
#if	defined(__NEED_SHUTDOWN__)
const unsigned char	at_smso[] = "at^smso\r" ;
void	gsm_sendSHUTDOWN(void)
{
	GSM_IGT = 1 ;
	mx = 0 ;
	while(at_smso[mx] != '\0')	gsm_TxEnQueue(at_smso[mx++]) ;
	EC = 0 ; g_linkTime = 5000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}
#endif

const unsigned char at_csq[] = "at+csq\r" ;
void	gsm_sendATPCSQ(void)
{
	mx = 0 ;
	while(at_csq[mx] != '\0')	gsm_TxEnQueue(at_csq[mx++]) ;	
	EC = 0 ; g_linkTime = 2000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}

/*
**	The buffer gsmResponse has in it the signal quality command and the response.
**	The tokens delimited by newlines, '\n', are stored in gsm_token[n]
**
**	gsm_token[0] is the command
**	gsm_token[1] is the response
*/
const unsigned char pCSQ[] = "+CSQ: " ;
unsigned char jx ;
unsigned char sq ;
unsigned char	gsm_signalQuality(void)
{
	sq = 0 ;
	jx = 0 ; mx = gsm_token[1] ;	/* The +CSQ: is here	*/
	while(pCSQ[jx] != '\0')
	{
		if(pCSQ[jx++] != gsmResponse[mx++])	return 255 ;
	}
	while(gsmResponse[mx] != ',')
	{
		sq = (sq * 10) + (gsmResponse[mx++] - '0') ;
	}
	return sq ;
}
const unsigned char at_sbc[] = "at^sbc?\r" ;
void	gsm_sendATUSBCQ(void)
{
	mx = 0 ;
	while(at_sbc[mx] != '\0')	gsm_TxEnQueue(at_sbc[mx++]) ;
	EC = 0 ; g_linkTime = 2000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}
const unsigned char uSBC[] = "^SBC: " ;
unsigned char gsm_batteryCapacity(void)
{
	sq = 0 ;
	jx = 0 ; mx = gsm_token[1] ;	/* The ^SBC: is here	*/
	while(uSBC[jx] != '\0')
	{
		if(uSBC[jx++] != gsmResponse[mx++]) return 255 ;
	}
	/* Skip everything up to and including the next comma	*/
	while(gsmResponse[mx++] != ',') ;
	while(gsmResponse[mx] != ',')
	{
		sq = (sq * 10) + (gsmResponse[mx++] - '0') ;
	}  
	return sq ;
}

const unsigned char at_cclke[] = "at+cclk=" ;
void	gsm_sendATPCCLKE(void)
{
	mx = 0 ;
	while(at_cclke[mx] != '\0')		gsm_TxEnQueue(at_cclke[mx++]) ;
	gsm_TxEnQueue('"') ;
	mx = 0 ;
	while(gsm_Clock[mx] != '\0')	gsm_TxEnQueue(gsm_Clock[mx++]) ;
	gsm_TxEnQueue('"') ;
	gsm_TxEnQueue('\r') ;
	EC = 0 ; g_linkTime = 2000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}	

const unsigned char	at_cclkq[] = "at+cclk?\r" ;
void	gsm_sendATPCCLKQ(void)
{
	mx = 0 ;
	while(at_cclkq[mx] != '\0')		gsm_TxEnQueue(at_cclkq[mx++]) ;
	EC = 0 ; g_linkTime = 2000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}	

const unsigned char	pCCLK[] = "+CCLK: \"" ;
void	gsm_updateClock(void)
{
	jx = 0 ;	mx = gsm_token[1] ;
	while(pCCLK[jx] != '\0')
	{
		if(pCCLK[jx++] != gsmResponse[mx++])	return ;
	}
	jx = 0 ;
	while(gsmResponse[mx] != '"')
	{
		gsm_Clock[jx++] = gsmResponse[mx++] ; 
	}
}
const unsigned char	at_snfs[] = "at^snfs=2\r" ;
void	gsm_sendATSNFS(void)
{
	mx = 0 ;
	while(at_snfs[mx] != '\0')		gsm_TxEnQueue(at_snfs[mx++]) ;
	EC = 0 ; g_linkTime = 2000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}

const unsigned char at_saic[] = "at^saic=2,2,1\r" ;
void	gsm_sendATSAIC(void)
{
	mx = 0 ;
	while(at_saic[mx] != '\0')		gsm_TxEnQueue(at_saic[mx++]) ;
	EC = 0 ; g_linkTime = 2000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}
const unsigned char at_clvl[] = "at+clvl=" ;
void	gsm_sendATPCLVL(void)
{
	mx = 0 ;
	while(at_clvl[mx] != '\0')		gsm_TxEnQueue(at_clvl[mx++]) ;
	gsm_TxEnQueue(p_SpeakerVolume + '1') ;
	gsm_TxEnQueue('\r') ;
	EC = 0 ; g_linkTime = 2000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}



#define	__NEED_SENDATD__
#if	defined(__NEED_SENDATD__)
#define	__VOICECALL_HNW__
#undef	__VOICECALL_HNW__
#define	__VOICECALL_BEEPIT__
#if	defined(__VOICECALL_HNW__)
const unsigned char at_d[] = "atd9952637;\r" ;
#elif	defined(__VOICECALL_BEEPIT__)
const unsigned char	at_d[] = "atd7097297;\r" ;
#else
#error	No Voicecall Number Selected
#endif

void	gsm_sendATD(void)
{
	mx = 0 ;
	while(at_d[mx] != '\0')		gsm_TxEnQueue(at_d[mx++]) ;
	EC = 0 ; g_linkTime = 16000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}

const unsigned char at_h[] = "ath\r" ;
void	gsm_sendATH(void)
{
	mx = 0 ;
	while(at_h[mx] != '\0')		gsm_TxEnQueue(at_h[mx++]) ;
	EC = 0 ; g_linkTime = 10000 ;		/* Establish a timeout interval	*/
	EC = 1 ;
}
			
#endif
	
void	gsm_Init(void)
{
	/*	Called with interrupts disabled		*/

	GSMU_CS = 0 ;		/* Take GPS UART Chip Select Active					*/

	SPDAT = GSM_UART_CONFIGURATION/256 ;
	while((SPSTA & SPIF) == 0) ;
	SPI_IN[0] = SPDAT ;
	
	SPDAT = GSM_UART_CONFIGURATION%256 ;
	while((SPSTA & SPIF) == 0) ;
	SPI_IN[1] = SPDAT ;

	GSMU_CS = 1 ;		/* Take GPS UART Chip Select Inactive	*/
	gsm_SetClock() ;

#if	defined(__OLD_GSM_MONITOR__)	
	GSM_IGT = 0 ;
#endif
}

/*
**	External Interupt 0 - EX0
*/
interrupt [0x0003] using [3] void IE0_int(void)
{
	do
	{
		GSMU_CS = 0 ;		/* Activate UART Chip Select						*/
							/* A Data Read is required to clear the interrupt	*/
	
		SPDAT = SPI_UART_READ/256 ;		/* Send 1st byte of Transaction			*/
		while((SPSTA & SPIF) == 0) ;	/* Wait for completion					*/
		SPI_IN[0] = SPDAT ;				/* Read the Result						*/

		SPDAT = SPI_UART_READ%256 ;		/* Send 2nd byte of Transaction			*/	
		while((SPSTA & SPIF) == 0) ;	/* Wait for completion					*/
		SPI_IN[1] = SPDAT ;				/* Read the data character				*/
	
		GSMU_CS = 1 ;		/* Deactivate UART Chip Select						*/
	
	
		if(SPI_IN[0] & SPI_UART_R)	/* Valid Character	*/
		{
			if(gsm_nRx < 255)		/* Check to see if there is room		*/
			{
				gsm_RxBuffer[gsm_RxPut] = SPI_IN[1] ;
				++gsm_RxPut ;
				++gsm_nRx ;
			}
			else	/* One space remains	*/
			{
				gsm_RxBuffer[gsm_RxPut] = '%' ;			/* Put overrun character in buffer	*/
			}
		}
		if(SPI_IN[0] & SPI_UART_T)
		{
			if(gsm_nTx > 0)	/* Are there characters to send?		*/
			{
				GSMU_CS = 0 ;	/* Activate GSM UART Chip Select	*/
			
				SPDAT = SPI_UART_WRITE/256 ;		/* Send 1st byte of Transaction	*/
				while((SPSTA & SPIF) == 0) ;		/* Wait for completion			*/
				SPI_IN[0] = SPDAT ;					/* Consume the data				*/
			
				SPDAT = gsm_TxBuffer[gsm_TxGet++] ;	/* Send 2nd byte of Transaction	*/
				--gsm_nTx ;
				while((SPSTA & SPIF) == 0) ;		/* Wait for completion			*/
				SPI_IN[1] = SPDAT ;					/* Consume the data				*/
			
				GSMU_CS = 1 ;	/* Deactivate GSM UART Chip Select					*/
			
				if(SPI_IN[0] & SPI_UART_R)	/* Check for Additional RX Character	*/
				{
					if(gsm_nRx < 255)		/* Check to see if there is room		*/
					{
						gsm_RxBuffer[gsm_RxPut] = SPI_IN[1] ;
						++gsm_RxPut ;
						++gsm_nRx ;
					}
					else	/* One space remains	*/
					{
						gsm_RxBuffer[gsm_RxPut] = '%' ;			/* Put overrun character in buffer	*/ 
					}
				}
			}
			else
			{
				gsmTDRE = 1 ;
			}
		}
	} while (GSMU_INT == 0) ;	
}

unsigned char	gsm_RxDeQueue(void)
{
	EX0 = 0 ;	/* Disable GSM Interrupts	*/
	if(gsm_nRx > 0)	/* Check to see if there are any characters	*/
	{
		--gsm_nRx ;
		B = gsm_RxBuffer[gsm_RxGet++] ;
	}
	else
	{
		B = '\x80' ;
	}
	EX0 = 1 ;	/* Enable GSM Interrupts	*/
	return B ;
}

/*
**	gsm_TxEnQueue
**	This routine has to manage both external interrupt enable bits because both
**	the gps UART and the gsm UART use the SPI port to move data in and out
*/
void	gsm_TxEnQueue(unsigned char c)
{
	if(gsm_nTx < 255)	/* Check to see if there is room						*/
	{
		EX0 = 0 ;	/* Disable GSM Interrupts									*/
		gsm_TxBuffer[gsm_TxPut++] = c ;
		++gsm_nTx ;
		if(gsmTDRE == 1)	/* Check to see if transmitter is running			*/
		{
			gsmTDRE = 0 ;	/* Reset the transmitter data register empty bit	*/
			EX1 = 0 ;		/* Disable GPS Interrupts							*/
			GSMU_CS = 0 ;	/* Activate GSM UART chip Select					*/
			
			SPDAT = SPI_UART_WRITE/256 ;	/* Send 1st byte of Transaction		*/
			while((SPSTA & SPIF) == 0) ;	/* Wait for completion				*/
			SPI_IN[0] = SPDAT ;				/* Consume the data					*/
			
			SPDAT = gsm_TxBuffer[gsm_TxGet++] ;	/* Send 2nd byte of Transaction	*/
			--gsm_nTx ;
			while((SPSTA & SPIF) == 0) ;	/* Wait for completion				*/
			SPI_IN[1] = SPDAT ;				/* Consume the data					*/
			
			GSMU_CS = 1 ;	/* Deactivate GSM UART Chip Select					*/
			EX1 = 1 ;		/* Enable GPS Interrupts							*/
		}
		else
		{
		}
		EX0 = 1 ;	/* Enable GSM Interrupts									*/
	}
	else	return ;
}

#if	defined(__OLD_GSM_MONITOR__)
/*	gsm_decodeResponse
**	This routine expects a null terminated string in the buffer gsmResponse
**	There may be leading characters in the buffer.  The response begins at gsm_rx
**	and it ends at gsm_x
*/
const unsigned char gsm_OK[]		= "OK" ;
const unsigned char gsm_ERROR[]		= "ERROR" ;
unsigned char rx ;

unsigned char	gsm_decodeResponse(void)
{
	if(gsmRCMP == 0)	return '\0' ;
	if(gsm_x > gsm_token[1])
	{
		mx = 0 ; rx = gsm_token[1] ; 
		while(gsm_OK[mx] != '\0')
		{
			if(gsm_OK[mx] == gsmResponse[rx])
			{	++mx ; ++rx ; continue ;	}
		}
		if(gsmResponse[rx] == '\r') return '\x01' ;
		
		mx = 0 ; rx = gsm_token[1] ;
		while(gsm_ERROR[mx] != '\0')
		{
			if(gsm_ERROR[mx] == gsmResponse[rx])
			{	++mx ; ++rx ; continue ;	}
		}
		if(gsmResponse[rx] == '\r')	return '\x02' ;
		
		mx = 0 ; rx = gsm_token[1] ;
		if(gsmResponse[rx] == '+')	/* It may be a URC	*/
		{
			/* Ignore the URC and keep looking			*/
			return '\x03' ;
		}
		else return '\x04' ;	 
	}
	else	return '\0' ;
}
#endif

extern void	dumpResponse(void) ;

/*
**	gsm_bufferClaim
**
**	This will do all the initialization required to send an "at" command to the modem
**	and prepare to receive the response.  The "response" will include an echo of the 
**	command characters.
*/
void	gsm_bufferClaim(void)
{
	gsmRCMP			= 0 ;		/* This is the gsm Response Complete Flag											*/
	gsm_newlines	= 0 ;		/* This is the newline counter. It increments each time a newline is encountered	*/	 
	gsm_x  			= 0 ;		/* This is the index into the response buffer										*/
	gsmResponse[0]	= 0 ;		/* This invalidates the current contents of the buffer								*/
	gsm_token[1]	= 0 ;
	gsm_ATRetry		= 0 ;
}
#if	defined(__NEW_GSM_MONITOR__)

void	gsmSequence(void)
{
	switch(gsm_service)
	{
		case GSM_SVC_MONITOR :		/*	0	*/
			gsm_status = GSM_SUCCESS ;
			break ;
		case GSM_SVC_PANIC :		/*	10	*/
		case GSM_SVC_PERIODIC :		/*	11	*/
		case GSM_SVC_COLDRESET :	/*	12	*/
		case GSM_SVC_WARMRESET :	/*	13	*/
		case GSM_SVC_SMSMESSAGE :	/*	14	*/
			GSM_IGT = 0 ;	/* Turn the modem on	*/
			gsm_status = gsm_service ;
			EC = 0 ; g_linkTime = 1200 ;	/* Establish the ignition timeout interval	*/
			EC = 1 ;
			gsm_state = GSM_WAIT ;
			break ;
		default :
			gsm_status = GSM_INVALID_SERVICE ;
			break ;
	}
	gsm_service = 0 ;
}

void	gsmMonitor(void)
{
unsigned char ch ;
	
	if(gsmEcho == 1)
	{	/* This allows us to insert commands from the monitor keyboard		*/
		if(gsm_nRx > 0)	/* If there are characters in the GSM UART Rx Queue	*/
		{	/* Then DeQueue them and echo them to the monitor				*/
			putch(gsm_RxDeQueue()) ;
		}
	}
	else	/* This section implements the GSM State Machine	*/
	{
		switch(gsm_state)
		{
			case GSM_SLEEP :		/*	0	*/
				/*	Check for a variety of wakeup commands	*/
				gsmSequence() ;
				break ;		
			case GSM_SENDATPCMGF :	/*	1	*/
				if(gsmTXPEND == 0)
				{	gsm_bufferClaim() ;	gsm_maxtoken = 1 ;
					gsm_sendATPCMGF() ;
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					EC = 1 ;
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_SENDATPCMEE ;
				}
				EC = 1 ;
				break ;
				
			case GSM_SENDATPCNMI :	/*	2	*/
				break ;
			case GSM_SENDATPCMGS :	/*	3	*/
				/* Send an SMS Command								*/
				if(gsmTXPEND == 0)	/* 1 if there is a command pending	*/
				{	gsm_bufferClaim() ; gsm_maxtoken = 2 ;
					gsm_sendATPCMGS() ;		/* Send at+cmgs	to dial the phone			*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;			/* Set the TX PENDING FLAG					*/
				}
				if(gsmRCMP == 1)
				{
					dumpResponse() ;
					if(	(gsmResponse[gsm_token[1]]		== '>') &&
						(gsmResponse[gsm_token[1]+1]	== ' ') )
					{
						gsmTXPEND = 0 ;
						EC = 0 ; g_linkTime = 0 ;
						EC = 1 ;
						if(gsm_status == GSM_SEQ_PANIC)
						{
							gsm_state = GSM_SENDEMERGENCY ;
						}
						else
						{
							gsm_state = GSM_SENDSMSTEXT ;
						}
					}
				}
				EC = 0 ; if((g_linkTime == 0) && (gsmTXPEND == 1))
				{
					gsmTXPEND = 0 ;
					/* Try Again	*/
				}
				EC = 1 ;
				break ;
			case GSM_SENDEMERGENCY :	/*	20	*/
				/* Send SMS Emergency Message	*/
				if(gsmTXPEND == 0)	/* 1 if there is a command pending	*/
				{
					gsm_bufferClaim() ;
					gsm_maxtoken = 6 ;
					gsm_sendEMERGENCY() ;		/* Send the emergency string			*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;			/* Set the TX PENDING FLAG					*/
					++nCall ;
				}
				EC = 0  ; if((g_linkTime == 0))
				{
					EC = 1 ;
					dumpResponse() ;
					gsmTXPEND = 0 ;
					if(nCall >= 1)	/* Desired number of calls placed ?	*/
					{
						if(p_911CallDelay == 6)
						{
							gsm_state = GSM_SHUTDOWN ;
						}
						else
						{
							gsm_state = GSM_HANGUP ;
						}
					}
					else
					{
						gsm_state = GSM_SENDATPCMGS ;
					}
				}
				EC = 1 ;				
				break ;
			case GSM_SENDSMSTEXT :	/*	4	*/
				/* Send SMS Text		*/
				if(gsmTXPEND == 0)	/* 1 if there is a command pending	*/
				{
					gsm_bufferClaim() ;
					gsm_maxtoken = 6 ;
					gsm_sendSMSTEXT() ;		/* Send at+cmgs	to dial the phone			*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;			/* Set the TX PENDING FLAG					*/
				}
				EC = 0  ; if((g_linkTime == 0))
				{
					EC = 1 ;
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_SHUTDOWN ;
				}
				EC = 1 ;				
				break ;
			case GSM_WAIT :			/*	5	*/
				EC = 0 ; if(g_linkTime == 0)
				{
					EC = 1 ;
					gsm_state = GSM_SENDATR ;
				}
				EC = 1 ;
				break ;
			case GSM_SHUTDOWN :		/*	6	*/
				if(gsmTXPEND == 0)
				{	gsm_bufferClaim() ; gsm_maxtoken = 2 ;
					gsm_sendSHUTDOWN() ;
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					EC = 1 ;
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_SLEEP ;
					if(gsm_status == GSM_SEQ_PANIC)
					{
						SPKR_SHDN = 0 ;
						GSM_IGT = 1 ;
						gsmCall = 0 ;

					}
					gsm_status = 0 ;
				}
				EC = 1 ;
				break ;
			case GSM_MODEMOFF :		/*	7	*/
				break ;
			case GSM_SENDATPCMEE :	/*	8	*/
				if(gsmTXPEND == 0)
				{	gsm_bufferClaim() ;	gsm_maxtoken = 1 ;
					gsm_sendATPCMEE() ;
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					EC = 1 ;
					dumpResponse() ;
					gsmTXPEND = 0 ;
					if(gsm_status == GSM_SEQ_PANIC)
					{
						if(p_911CallDelay == 6)
						{
							gsm_state = GSM_SENDATPCMGS ;
						}
						else
						{
							gsm_state = GSM_SPEAKERVOLUME ;
						}
					}
					else
					{
						gsm_state = GSM_SENDATPCMGS ;
					}
				}
				EC = 1 ;
				break ;
			case GSM_SENDATR :		/*	9	*/
				if(gsmTXPEND == 0)
				{	gsm_bufferClaim() ; gsm_maxtoken = 1 ;
					gsm_sendATR() ;		/* Send command at\r and start link timer	*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;		/* Set the TX PENDING FLAG					*/
				}
				EC = 0 ; if(g_linkTime == 0)
				{	/* Command Timeout	*/
					EC = 1 ;
					dumpResponse() ;
					gsmTXPEND = 0 ;
					switch(gsm_status)
					{
						case GSM_SEQ_COLDRESET :	/*	12	*/
							gsm_state = GSM_SETCLOCK ;
							break ;				
						case GSM_SEQ_WARMRESET :	/*	13	*/
							gsm_state = GSM_GETCLOCK ;
							break ;
						case GSM_SEQ_PERIODIC :		/*	11	*/
							gsm_state = GSM_BATTERY ;
							break ;
						case GSM_SEQ_SMSMESSAGE :		/*	14	*/
						case GSM_SEQ_PANIC :		/*	10	*/
							gsm_state = GSM_SIGNAL ;
							break ;
						default :
							gsm_state = GSM_SHUTDOWN ;
							break ;
					}
				}
				EC = 1 ;
				break ;
			case GSM_GETCLOCK :		/*	10	*/
				if(gsmTXPEND == 0)
				{	gsm_bufferClaim() ; gsm_maxtoken = 1 ;
					gsm_sendATPCCLKQ() ;
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;		/* Set the TX PENDING FLAG					*/
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					EC = 1 ;
					gsm_updateClock() ;
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_BATTERY ;
				}
				EC = 1 ;
				break ;
			case GSM_SETCLOCK :		/*	11	*/
				if(gsmTXPEND == 0)
				{	gsm_bufferClaim() ; gsm_maxtoken = 1 ;
					gsm_sendATPCCLKE() ;	/* Send Command to set the clock	*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					EC = 1 ;
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_BATTERY ;
				}
				EC = 1 ;
				break ;
			case GSM_SPEAKERVOLUME :	/*	21	*/
				if(gsmTXPEND == 0)
				{	gsm_bufferClaim() ; gsm_maxtoken = 1 ;
					switch(p_SpeakerVolume)
					{
						default :	p_SpeakerVolume = 1 ;
						case 1 :
						case 2 :
						case 3 :
							SPKR_SHDN = 1 ;
							gsm_sendATPCLVL() ;	/* Send Command to set the Speaker Level Mode	*/
							EC = 0 ; g_intervalTimer = 0 ;
							EC = 1 ;
							gsmTXPEND = 1 ;
							break ;
						case 4 :
							SPKR_SHDN = 0 ;
							EC = 0 ; g_linkTime = 0 ;
							EC = 1 ;
							break ;
					}
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_AUDIOCHANNELS ;
				}
				EC = 1 ;
				break ;
			case GSM_AUDIOMODE :	/*	12	*/
				if(gsmTXPEND == 0)
				{	gsm_bufferClaim() ; gsm_maxtoken = 1 ;
					gsm_sendATSNFS() ;	/* Send Command to set the Audio Mode	*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_AUDIOCHANNELS ;
				}
				EC = 1 ;
				break ;
			case GSM_AUDIOCHANNELS :/*	13	*/
				if(gsmTXPEND == 0)
				{	gsm_bufferClaim() ;	gsm_maxtoken = 1 ;
					gsm_sendATSAIC() ;	/* Send Command to set the Audio Mode	*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_VOICECALL ;
				}
				EC = 1 ;
				break ;
			case GSM_VOICECALL :	/*	14	*/
				if(gsmTXPEND == 0)
				{	gsm_bufferClaim() ; gsm_maxtoken = 1 ;
					gsm_sendATD() ;
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_SENDATPCMGS ;
				}
				EC = 1 ;
				break ;
			case GSM_SIGNAL :		/*	15	*/
				if(gsmTXPEND == 0)
				{	gsm_bufferClaim() ; gsm_maxtoken = 3 ;
					gsm_sendATPCSQ() ;	/* Send Command to check signal quality	*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					EC = 1 ;
					g_CSQ = gsm_signalQuality() ;
					dumpResponse() ;
					putch('C') ; putch('S') ; putch('Q') ; putch ('=') ;
					puthex(g_CSQ) ;
					putch('\r') ; putch('\n') ;
					gsmTXPEND = 0 ;
					if(g_CSQ <= 31)	/* Valid Signal	*/
					{
						switch(gsm_status)
						{
							case GSM_SEQ_COLDRESET :	/*	12	*/
							case GSM_SEQ_WARMRESET :	/*	13	*/
							case GSM_SEQ_PERIODIC :		/*	11	*/
							default :
								gsm_state = GSM_SHUTDOWN ;
								break ;
							case GSM_SEQ_SMSMESSAGE :		/*	14	*/
							case GSM_SEQ_PANIC :		/*	10	*/
								gsm_state = GSM_SENDATPCMGF ;
								break ;
						}
					}	/* else continue looking for signal	*/
				}
				EC = 1 ;
				break ;
			case GSM_BATTERY :		/*	16	*/
				if(gsmTXPEND == 0)
				{
					gsm_bufferClaim() ;
					gsm_ATRetry = 1 ;
					gsm_maxtoken = 3 ;
					gsm_sendATUSBCQ() ;		/* Send Command to check battery	*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;
				}
				EC = 0  ; if(g_linkTime == 0)
				{
					EC = 1 ;
					g_SBC = gsm_batteryCapacity() ;
					dumpResponse() ;
					putch('S') ; putch('B') ; putch('C') ; putch('=') ;
					puthex(g_SBC) ;
					putch('\r') ; putch('\n') ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_SIGNAL ;
				}
				EC = 1 ;
				break ;
			case GSM_HANGUP :
				if(gsmTXPEND == 0)
				{	gsm_bufferClaim() ; gsm_maxtoken = 1 ;
					gsm_sendATH() ;
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_SHUTDOWN ;
				}
				EC = 1 ;
				break ;
			case GSM_IDLE :			/*	17	*/
			case GSM_NOP :			/*	18	*/
			default :
				break ;
		}
		if(gsm_nRx > 0)
		{
			
			gsmResponse[gsm_x++] = ch = gsm_RxDeQueue() ;  
			gsmResponse[gsm_x] = '\0' ;
			putch(ch) ;
			switch(ch)
			{
				case '\n' :
					++gsm_newlines ;
					if(gsm_newlines == 1)
					{
							gsm_token[1] = gsm_x ;
					}
					else
					{
						if(gsm_newlines < 10)
						{
							gsm_token[gsm_newlines]		= gsm_x ;
							gsm_token[gsm_newlines+1]	= '\0' ;
						}
					}
					if(gsm_newlines > gsm_maxtoken)
					{
						gsmRCMP = 1 ;
						EC = 0 ; gsm_time = g_intervalTimer ;
						EC = 1 ;
					}
					break ;
				case ' ' :
					if(gsm_token[1] > 0)
					{
						if(gsmResponse[gsm_token[1]] == '>')
						{
							gsmRCMP = 1 ;
							EC = 0 ; gsm_time = g_intervalTimer ;
							EC = 1 ;
						}
					}
					break ;
				default :	
					break ;
			}
		}
	}
}
#elif	defined(__OLD_GSM_MONITOR__)
#include	"oldgsm.inc"
#else
#error	No GSM Monitor Selected
#endif

































