/*
**  intstub.c
**  (c)Huron Net Works, Inc., 2005
**
**  Interrupt Stub Definition
**
**	7/1/05	-- Original
**
**  TABS 5, 9
*/
#include	"hardware.h"
#include	"externs.h"

/* External Interrupt 0			*/
/* Moved to gsm.c				*/

/* Timer 0 Interrupt			*/
interrupt [0x000B] using [1] void TF0_int(void)		{	reloadTimer0() ;	}

/* External Interrupt 1			*/
/* Moved to gps.c				*/

/*	Timer 1 Interrupt			*/
interrupt [0x001B] using [1] void TF1_int(void)		{	reloadTimer1() ;	}

/*	UART Interrupt				*/
/*	moved to file sport.c		*/

/* Timer 2 Interrupt			*/
interrupt [0x2B] using [0] void TF2_int(void)		{	ET2 = 0 ; EXEN2 = 0 ;	}


/*	PCA Interrupt				*/
interrupt [0x0033] using [1] void PCA_int(void)
{
	/* Clear any spurious bits	*/
#if	defined(__LP_MODE__)
	CCON	&=	CRBIT +	CCF4BIT + CCF3BIT ;
	if(CCF3 == 1)
	{
		CCF3 = 0 ;
		reloadWakeupTimer() ;
	}
#else	
	CCON	&=	CRBIT +	CCF4BIT ;
	if(CCF4 == 1)
	{
		CCF4 = 0 ;
		reloadTickTimer() ;
		++g_Tick ;
		if(g_Tick == g_flashTime)
		{
			ONE_QSECOND = 1 ;
			led_update() ;
			g_flashTime += 250 ;
		}
		if(g_Tick == g_oneSecond)
		{
			ONE_SECOND = 1 ;
			g_oneSecond += 1000 ;
			if(PA_Repeat != 0)
			{
				--PA_Repeat ;
			}
			if(gsm_periodic != 0)
			{
				--gsm_periodic ;
			}
			if(gps_Timer != 0)
			{
				--gps_Timer ;
			}
		}
		if(g_ringTime != 0)
		{
			--g_ringTime ;
		}
		if(g_chirpTime != 0)
		{
			--g_chirpTime ;
		}
		if(g_keyTime != 0)
		{
			--g_keyTime ;
		}
		if(g_linkTime != 0)
		{
			--g_linkTime ;
		}
		if(g_waitTime != 0)
		{
			--g_waitTime ;
		}
		if(g_repeat != 0)
		{
			--g_repeat ;
		}
		if(PA_Timer < 65535)
		{
			++PA_Timer ;
		}
		if(g_intervalTimer < 65535)
		{ 
			++g_intervalTimer ;
		}
		if(g_debounce != 0)
		{
			--g_debounce ;
			if(g_debounce == 0)
			{
				if((P1 ^ KBLS) & PANIC)
				{	/* We are bouncing -- wait more		*/
					g_debounce = 4 ;
				}
				else
				{	/* We have the event we were loking for	*/
					if(KBLS & PANIC)
					{
						PANIC_DOWN = 0 ;
						PANIC_UP = 1 ;
					}
					else
					{
						PANIC_UP = 0 ;
						PANIC_DOWN = 1 ;
					}
				}
			}
		}
	}
}

/*	Keyboard Interrupt			*/
interrupt [0x003B] using [1] void KBD_int(void)
{
	KBF = 0 ;			/* Clear the flag				*/
	KBE = 0 ;			/* Disable further interrupts	*/
	g_debounce = 12 ;	/* Start a 20 msec. timer		*/
}

/*	Unassigned Interrupt		*/
interrupt [0x0043] using [0] void NULL_int(void)	{	}



