/*
**  keyboard.c
**  (c)Huron Net Works, Inc., 2005
**
**	Keyboard Driver
**
**  TABS 5, 9
*/
#include	"hardware.h"
#include	"externs.h"

#define	KEY_MASK	(1<<4)+(1<<3)+(1<<2)+(1<<1)+(1<<0)

const unsigned char	key_table[32] =
{
	KENTER,	KUP,	KENTER,	KDOWN,	KENTER,	KUP,	KENTER,	KRIGHT,
	KENTER,	KUP,	KENTER,	KDOWN,	KENTER,	KUP,	KENTER,	KLEFT,
	KENTER,	KUP,	KENTER,	KDOWN,	KENTER,	KUP,	KENTER,	KRIGHT,
	KENTER, KUP,	KENTER,	KDOWN,	KENTER,	KUP,	KENTER,	0	
} ;


void	kbd_Init(void)
{
	bkey[0] = bkey[1] = bkey[2] = 0x1F ;
}

void	getch(void)
{
	g_key = 0 ;
	if(g_keyTime != 0) return ;

/*	This is the key sampling shift register	*/	
	bkey[2] = bkey[1] ;
	bkey[1] = bkey[0] ;
	bkey[0] = P4 & KEY_MASK ;

	EC = 0 ;
	g_keyTime = KEY_DEBOUNCE ;				/* Set the sampling Interval	*/
		
	if(bkey[0] != bkey[1])			/* Transition Detector			*/
	{
		g_repeat = 0 ;
		EC = 1 ;
	}
	else	/* Last two samples are equal							*/
	{
		if(bkey[1] != bkey[2])			/*	We are debounced		*/
		{
			if(bkey[0] == KEY_MASK)		/* Was this a release?		*/
			{							/* It was a release			*/
				g_repeat = 0 ;
				EC = 1 ;
			}
			else
			{
				g_key = key_table[bkey[0]] ;
				g_repeat = KEY_REPEAT_INITIAL ;		/* Start a repeat timer		*/
				EC = 1 ;
			}
		}
		else	/* Last three samples are equal						*/
		{
			if(bkey[0] == KEY_MASK)		/* Was this a release?		*/
			{
				g_repeat = 0 ;			/*	Kill the repeat timer	*/
				EC = 1 ;
			}
			else
			{
				if(g_repeat == 0)
				{
					g_repeat = KEY_REPEAT ;	/* 5 times per second		*/
					g_key = key_table[bkey[0]] ;
				}
				EC = 1 ;
			}
		}
	}
}