/*
**  led.c
**  (c)Huron Net Works, Inc., 2005
**
**	LED state machine
**
**	15 Sep 2005 -- Original
**  TABS 5, 9
*/
#include	"hardware.h"
#include	"externs.h"

/*
**	led_update is called from a timer interrupt service routine
*/
void	led_update(void)
{
	if(led_input >= 128)	/* State Change if true	*/
	{
		led_state = led_input & 0x7F ;
		led_input = LED_HOLD ;
	}
	/*	If there is no state change then process the current state	*/
	switch(led_state)
	{
		case LED_OFF :
			REDC = 1 ; GRNC = 1 ;		/* Take both cathodes high							*/
			break ;
		case LED_RED :
			REDC = 0 ; GRNC = 1 ;		/* Take RED low and GREEN High						*/
			break ;
		case LED_GREEN :
			REDC = 1 ; GRNC = 0 ;		/* Take RED high and GREEN low						*/
			break ;
		case LED_FLASH_RED :
			REDC = ~REDC ; GRNC = 1 ;	/* Complement RED and take GREEN high				*/
			break ;
		case LED_FLASH_GREEN :
			REDC = 1 ; GRNC = ~GRNC ;	/* Take RED High and Complement GREEN				*/
			break ;
		case LED_RAILROAD :
			if(REDC != GRNC) P4 ^= ((1<<7)+(1<<6)) ;	/* Complement both REDC and GRNC	*/
			else
			{	/* Start on GREEN	*/
				REDC = 1 ; GRNC = 0 ;		/* Take RED high and GREEN low					*/
			}
			break ;
		default :
			REDC = 0 ; GRNC = 0 ;		/* Take both low on ERROR				*/
			break ;
	}
}