/*
**  monitor.c
**  (c)Huron Net Works, Inc., 2005
**
**  Initialization Definition
**
**	7/5/05	-- Original
**
**  TABS 5, 9
*/
#include	"hardware.h"
#include	"externs.h"


const	unsigned char bn[]	= "Beep-It WX-911\r\n" ;
const	unsigned char cold[] = "Cold Reset \r\n" ;
const	unsigned char warm[] = "Warm Reset \r\n" ;

unsigned char	x ;
unsigned char	c ;
unsigned char	kbm ;
unsigned char	p ;
unsigned char	b ;
unsigned char	t ;

void	putch(unsigned char c)
{
	sp_TxEnQueue(c) ;
}

void	puthex(unsigned char h)
{
	t = h >> 4 ;
	if(t <= 9) t = t + '0' ;
	else t = t + ('A' - 10) ;
	putch(t) ;
	t = h & 15 ;
	if(t <= 9) t = t + '0' ;
	else t = t + ('A' - 10) ;
	putch(t) ;
}

#define	__PUTINT_REQUIRED__
#if	defined(__PUTINT_REQUIRED__)
void	putint(unsigned int i)
{
	puthex(i >> 8) ;
	puthex(i &  255) ;
}
#endif
/*
**	Display the banner
*/
void	banner(void)
{
	for(x=0;;)
	{
		if(bn[x] == '\0')	break ;
		sp_TxEnQueue(bn[x++]) ;
	}
	if(ST_POF)	/* Selftest Power On Flag = PCON & POF	*/
	{
		for(x=0;;)
		{
			if(cold[x] == '\0')	break ;
			sp_TxEnQueue(cold[x++]) ;
		}
	}
	else
	{
		for(x=0;;)
		{
			if(warm[x] == '\0')	break ;
			sp_TxEnQueue(warm[x++]) ;
		}
	}
}

void	biton(void)
{
	switch(p)
	{
		case 0 :
			switch(b)
			{
				case 0 :	P0.0 = 1 ;	break ;
				case 1 :	P0.1 = 1 ;	break ;
				case 2 :	P0.2 = 1 ;	break ;
				case 3 :	P0.3 = 1 ;	break ;
				case 4 :	P0.4 = 1 ;	break ;
				case 5 :	P0.5 = 1 ;	break ;
				case 6 :	P0.6 = 1 ;	break ;
				case 7 :	P0.7 = 1 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 1 :
			switch(b)
			{
				case 0 :	P1.0 = 1 ;	break ;
				case 1 :	P1.1 = 1 ;	break ;
				case 2 :	P1.2 = 1 ;	break ;
				case 3 :	P1.3 = 1 ;	break ;
				case 4 :	P1.4 = 1 ;	break ;
				case 5 :	P1.5 = 1 ;	break ;
				case 6 :	P1.6 = 1 ;	break ;
				case 7 :	P1.7 = 1 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 2 :
			switch(b)
			{
				case 0 :	P2.0 = 1 ;	break ;
				case 1 :	P2.1 = 1 ;	break ;
				case 2 :	P2.2 = 1 ;	break ;
				case 3 :	P2.3 = 1 ;	break ;
				case 4 :	P2.4 = 1 ;	break ;
				case 5 :	P2.5 = 1 ;	break ;
				case 6 :	P2.6 = 1 ;	break ;
				case 7 :	P2.7 = 1 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 3 :
			switch(b)
			{
				case 0 :	P3.0 = 1 ;	break ;
				case 1 :	P3.1 = 1 ;	break ;
				case 2 :	P3.2 = 1 ;	break ;
				case 3 :	P3.3 = 1 ;	break ;
				case 4 :	P3.4 = 1 ;	break ;
				case 5 :	P3.5 = 1 ;	break ;
				case 6 :	P3.6 = 1 ;	break ;
				case 7 :	P3.7 = 1 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 4 :
			switch(b)
			{
				case 0 :	P4.0 = 1 ;	break ;
				case 1 :	P4.1 = 1 ;	break ;
				case 2 :	P4.2 = 1 ;	break ;
				case 3 :	P4.3 = 1 ;	break ;
				case 4 :	P4.4 = 1 ;	break ;
				case 5 :	P4.5 = 1 ;	break ;
				case 6 :	P4.6 = 1 ;	break ;
				case 7 :	P4.7 = 1 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 5 :
			switch(b)
			{
				case 0 :	P5.0 = 1 ;	break ;
				case 1 :	P5.1 = 1 ;	break ;
				case 2 :	P5.2 = 1 ;	break ;
				case 3 :	P5.3 = 1 ;	break ;
				case 4 :	P5.4 = 1 ;	break ;
				case 5 :	P5.5 = 1 ;	break ;
				case 6 :	P5.6 = 1 ;	break ;
				case 7 :	P5.7 = 1 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		default :
			putch('p') ; putch('?') ; putch(' ') ;
			break ;
	}
}
void	bitoff(void)
{
	switch(p)
	{
		case 0 :
			switch(b)
			{
				case 0 :	P0.0 = 0 ;	break ;
				case 1 :	P0.1 = 0 ;	break ;
				case 2 :	P0.2 = 0 ;	break ;
				case 3 :	P0.3 = 0 ;	break ;
				case 4 :	P0.4 = 0 ;	break ;
				case 5 :	P0.5 = 0 ;	break ;
				case 6 :	P0.6 = 0 ;	break ;
				case 7 :	P0.7 = 0 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 1 :
			switch(b)
			{
				case 0 :	P1.0 = 0 ;	break ;
				case 1 :	P1.1 = 0 ;	break ;
				case 2 :	P1.2 = 0 ;	break ;
				case 3 :	P1.3 = 0 ;	break ;
				case 4 :	P1.4 = 0 ;	break ;
				case 5 :	P1.5 = 0 ;	break ;
				case 6 :	P1.6 = 0 ;	break ;
				case 7 :	P1.7 = 0 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 2 :
			switch(b)
			{
				case 0 :	P2.0 = 0 ;	break ;
				case 1 :	P2.1 = 0 ;	break ;
				case 2 :	P2.2 = 0 ;	break ;
				case 3 :	P2.3 = 0 ;	break ;
				case 4 :	P2.4 = 0 ;	break ;
				case 5 :	P2.5 = 0 ;	break ;
				case 6 :	P2.6 = 0 ;	break ;
				case 7 :	P2.7 = 0 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 3 :
			switch(b)
			{
				case 0 :	P3.0 = 0 ;	break ;
				case 1 :	P3.1 = 0 ;	break ;
				case 2 :	P3.2 = 0 ;	break ;
				case 3 :	P3.3 = 0 ;	break ;
				case 4 :	P3.4 = 0 ;	break ;
				case 5 :	P3.5 = 0 ;	break ;
				case 6 :	P3.6 = 0 ;	break ;
				case 7 :	P3.7 = 0 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 4 :
			switch(b)
			{
				case 0 :	P4.0 = 0 ;	break ;
				case 1 :	P4.1 = 0 ;	break ;
				case 2 :	P4.2 = 0 ;	break ;
				case 3 :	P4.3 = 0 ;	break ;
				case 4 :	P4.4 = 0 ;	break ;
				case 5 :	P4.5 = 0 ;	break ;
				case 6 :	P4.6 = 0 ;	break ;
				case 7 :	P4.7 = 0 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 5 :
			switch(b)
			{
				case 0 :	P5.0 = 0 ;	break ;
				case 1 :	P5.1 = 0 ;	break ;
				case 2 :	P5.2 = 0 ;	break ;
				case 3 :	P5.3 = 0 ;	break ;
				case 4 :	P5.4 = 0 ;	break ;
				case 5 :	P5.5 = 0 ;	break ;
				case 6 :	P5.6 = 0 ;	break ;
				case 7 :	P5.7 = 0 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		default :
			putch('p') ; putch('?') ; putch(' ') ;
			break ;
	}
}
void	bittoggle(void)
{
	switch(p)
	{
		case 0 :
			switch(b)
			{
				case 0 :	P0.0 = ~P0.0 ;	break ;
				case 1 :	P0.1 = ~P0.1 ;	break ;
				case 2 :	P0.2 = ~P0.2 ;	break ;
				case 3 :	P0.3 = ~P0.3 ;	break ;
				case 4 :	P0.4 = ~P0.4 ;	break ;
				case 5 :	P0.5 = ~P0.5 ;	break ;
				case 6 :	P0.6 = ~P0.6 ;	break ;
				case 7 :	P0.7 = ~P0.7 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 1 :
			switch(b)
			{
				case 0 :	P1.0 = ~P1.0 ;	break ;
				case 1 :	P1.1 = ~P1.1 ;	break ;
				case 2 :	P1.2 = ~P1.2 ;	break ;
				case 3 :	P1.3 = ~P1.3 ;	break ;
				case 4 :	P1.4 = ~P1.4 ;	break ;
				case 5 :	P1.5 = ~P1.5 ;	break ;
				case 6 :	P1.6 = ~P1.6 ;	break ;
				case 7 :	P1.7 = ~P1.7 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 2 :
			switch(b)
			{
				case 0 :	P2.0 = ~P2.0 ;	break ;
				case 1 :	P2.1 = ~P2.1 ;	break ;
				case 2 :	P2.2 = ~P2.2 ;	break ;
				case 3 :	P2.3 = ~P2.3 ;	break ;
				case 4 :	P2.4 = ~P2.4 ;	break ;
				case 5 :	P2.5 = ~P2.5 ;	break ;
				case 6 :	P2.6 = ~P2.6 ;	break ;
				case 7 :	P2.7 = ~P2.7 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 3 :
			switch(b)
			{
				case 0 :	P3.0 = ~P3.0 ;	break ;
				case 1 :	P3.1 = ~P3.1 ;	break ;
				case 2 :	P3.2 = ~P3.2 ;	break ;
				case 3 :	P3.3 = ~P3.3 ;	break ;
				case 4 :	P3.4 = ~P3.4 ;	break ;
				case 5 :	P3.5 = ~P3.5 ;	break ;
				case 6 :	P3.6 = ~P3.6 ;	break ;
				case 7 :	P3.7 = ~P3.7 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 4 :
			switch(b)
			{
				case 0 :	P4.0 = ~P4.0 ;	break ;
				case 1 :	P4.1 = ~P4.1 ;	break ;
				case 2 :	P4.2 = ~P4.2 ;	break ;
				case 3 :	P4.3 = ~P4.3 ;	break ;
				case 4 :	P4.4 = ~P4.4 ;	break ;
				case 5 :	P4.5 = ~P4.5 ;	break ;
				case 6 :	P4.6 = ~P4.6 ;	break ;
				case 7 :	P4.7 = ~P4.7 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		case 5 :
			switch(b)
			{
				case 0 :	P5.0 = ~P5.0 ;	break ;
				case 1 :	P5.1 = ~P5.1 ;	break ;
				case 2 :	P5.2 = ~P5.2 ;	break ;
				case 3 :	P5.3 = ~P5.3 ;	break ;
				case 4 :	P5.4 = ~P5.4 ;	break ;
				case 5 :	P5.5 = ~P5.5 ;	break ;
				case 6 :	P5.6 = ~P5.6 ;	break ;
				case 7 :	P5.7 = ~P5.7 ;	break ;
				default :
					putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			break ;
		default :
			putch('p') ; putch('?') ; putch(' ') ;
			break ;
	}
}
void	bitshow(void)
{
	g_bits = 0 ;
	switch(p)
	{
		case 0 :
			putch('P') ; putch('0') ; putch('.') ; putch('0' + b) ; putch('=') ;
			switch(b)
			{
				case 0 :	g_bits.0 = P0.0 ;	break ;
				case 1 :	g_bits.1 = P0.1 ;	break ;
				case 2 :	g_bits.2 = P0.2 ;	break ;
				case 3 :	g_bits.3 = P0.3 ;	break ;
				case 4 :	g_bits.4 = P0.4 ;	break ;
				case 5 :	g_bits.5 = P0.5 ;	break ;
				case 6 :	g_bits.6 = P0.6 ;	break ;
				case 7 :	g_bits.7 = P0.7 ;	break ;
				default :
					putch(' ') ; putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			if(g_bits == 0)	putch('0') ;
			else			putch('1') ;
			putch(' ') ;
			break ;
		case 1 :
			putch('P') ; putch('1') ; putch('.') ; putch('0' + b) ; putch('=') ;
			switch(b)
			{
				case 0 :	g_bits.0 = P1.0 ;	break ;
				case 1 :	g_bits.1 = P1.1 ;	break ;
				case 2 :	g_bits.2 = P1.2 ;	break ;
				case 3 :	g_bits.3 = P1.3 ;	break ;
				case 4 :	g_bits.4 = P1.4 ;	break ;
				case 5 :	g_bits.5 = P1.5 ;	break ;
				case 6 :	g_bits.6 = P1.6 ;	break ;
				case 7 :	g_bits.7 = P1.7 ;	break ;
				default :
					putch(' ') ; putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			if(g_bits == 0)	putch('0') ;
			else			putch('1') ;
			putch(' ') ;
			break ;
		case 2 :
			putch('P') ; putch('2') ; putch('.') ; putch('0' + b) ; putch('=') ;
			switch(b)
			{
				case 0 :	g_bits.0 = P2.0 ;	break ;
				case 1 :	g_bits.1 = P2.1 ;	break ;
				case 2 :	g_bits.2 = P2.2 ;	break ;
				case 3 :	g_bits.3 = P2.3 ;	break ;
				case 4 :	g_bits.4 = P2.4 ;	break ;
				case 5 :	g_bits.5 = P2.5 ;	break ;
				case 6 :	g_bits.6 = P2.6 ;	break ;
				case 7 :	g_bits.7 = P2.7 ;	break ;
				default :
					putch(' ') ; putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			if(g_bits == 0)	putch('0') ;
			else			putch('1') ;
			putch(' ') ;
			break ;
		case 3 :
			putch('P') ; putch('3') ; putch('.') ; putch('0' + b) ; putch('=') ;
			switch(b)
			{
				case 0 :	g_bits.0 = P3.0 ;	break ;
				case 1 :	g_bits.1 = P3.1 ;	break ;
				case 2 :	g_bits.2 = P3.2 ;	break ;
				case 3 :	g_bits.3 = P3.3 ;	break ;
				case 4 :	g_bits.4 = P3.4 ;	break ;
				case 5 :	g_bits.5 = P3.5 ;	break ;
				case 6 :	g_bits.6 = P3.6 ;	break ;
				case 7 :	g_bits.7 = P3.7 ;	break ;
				default :
					putch(' ') ; putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			if(g_bits == 0)	putch('0') ;
			else			putch('1') ;
			putch(' ') ;
			break ;
		case 4 :
			putch('P') ; putch('4') ; putch('.') ; putch('0' + b) ; putch('=') ;
			switch(b)
			{
				case 0 :	g_bits.0 = P4.0 ;	break ;
				case 1 :	g_bits.1 = P4.1 ;	break ;
				case 2 :	g_bits.2 = P4.2 ;	break ;
				case 3 :	g_bits.3 = P4.3 ;	break ;
				case 4 :	g_bits.4 = P4.4 ;	break ;
				case 5 :	g_bits.5 = P4.5 ;	break ;
				case 6 :	g_bits.6 = P4.6 ;	break ;
				case 7 :	g_bits.7 = P4.7 ;	break ;
				default :
					putch(' ') ; putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			if(g_bits == 0)	putch('0') ;
			else			putch('1') ;
			putch(' ') ;
			break ;
		case 5 :
			putch('P') ; putch('5') ; putch('.') ; putch('0' + b) ; putch('=') ;
			switch(b)
			{
				case 0 :	g_bits.0 = P5.0 ;	break ;
				case 1 :	g_bits.1 = P5.1 ;	break ;
				case 2 :	g_bits.2 = P5.2 ;	break ;
				case 3 :	g_bits.3 = P5.3 ;	break ;
				case 4 :	g_bits.4 = P5.4 ;	break ;
				case 5 :	g_bits.5 = P5.5 ;	break ;
				case 6 :	g_bits.6 = P5.6 ;	break ;
				case 7 :	g_bits.7 = P5.7 ;	break ;
				default :
					putch(' ') ; putch('b') ; putch('?') ; putch(' ') ;
					break ;
			}
			if(g_bits == 0)	putch('0') ;
			else			putch('1') ;
			putch(' ') ;
			break ;
		default :
			putch(' ') ; putch('p') ; putch('?') ; putch(' ') ;
			break ;
	}
}

void	spMonitorInit(void)
{
	banner() ;	/* Display the banner	*/
	p = b = 1 ;
	kbm = 0 ;
}

unsigned char	xx ;
unsigned char	xc ;
void	dumpResponse(void)
{
	xx = xc = 0 ;
	putch('\r') ; putch('\n') ; putch('<') ;
	while(gsmResponse[xx] != '\0')
	{
		puthex(gsmResponse[xx++]) ;
		++xc ;
		putch(' ') ;
		if(sp_nTx > 192)
		{
			while(sp_nTx > 96) WATCHDOG ;
		}
	}
	putch('\b') ; putch('>') ;
	putch('\r') ; putch('\n') ;
	putch('L') ;  putch('=') ; puthex(xc) ; putch(',') ;
	putch('E') ;  putch('T') ; putch('=') ; putint(gsm_time) ;
	putch('\r') ; putch('\n') ;

	putch('T') ; putch('o') ; putch('k') ; putch('e') ; putch('n') ; putch('s') ; putch('=') ;
	puthex(gsm_token[0]) ; putch(',') ;
	puthex(gsm_token[1]) ; putch(',') ;
	puthex(gsm_token[2]) ; putch(',') ;
	puthex(gsm_token[3]) ; putch(',') ;
	puthex(gsm_token[4]) ; putch(',') ;
	puthex(gsm_token[5]) ; putch(',') ;
	puthex(gsm_token[6]) ; putch(',') ;
	puthex(gsm_token[7]) ; putch(',') ;
	puthex(gsm_token[8]) ; putch(',') ;
	puthex(gsm_token[9]) ; putch('\r') ; putch('\n') ;
}

unsigned char noEcho ;

void	spMonitor(void)
{
	noEcho = 0 ;
	if(sp_nRx > 0)	/* There are characters to process	*/
	{
		c = sp_RxDeQueue() ;
		if(c == '\x80') return ;
		switch(kbm)
		{
			case 0 :	/* looking for a 'p' or 's'	*/
				if(c == 'p')		{	kbm = 1 ;		}
				else if(c == 's')	{	kbm = 2 ;		}
				else if(c == 'l')	{	kbm = 3 ;		}
				else if(c == 'i')	{	kbm = 6 ;		}
				else if(c == 'g')	{	gpsEcho = 1 ;	kbm = 9 ;		}
				else if(c == 'm')	{	gsmEcho = 1 ;	kbm = 10 ;		}
				else if(c == ' ')	{	}
				else if(c == 'x')	{	dumpResponse() ;}
				else if(c == '%')	{	while(1) ;		}
				else				{	c = '?' ;		}
				break ;
			case 1 :	/* looking for digits	*/
				if(c == 'p')		{	kbm = 1 ;		}
				else if(c == 's')	{	kbm = 2 ;		}
				else if(c == 'l')	{	kbm = 3 ;		}
				else if(c == 'i')	{	kbm = 6 ;		}
				else if(c == 'g')	{	gpsEcho = 1 ;	kbm = 9 ;		}
				else if(c == 'm')	{	kbm = 10 ;		}
				else if(c == ' ')	{	}
				else if(c == '%')	{	while(1) ;		}
				else if((c <= '9') && (c >= '0'))
				{
					p = b ;
					b = c - '0' ;
				}
				else if(c == '+')	{	biton() ;		}
				else if(c == '-')	{	bitoff() ;		}
				else if(c == '=')
				{
					putch('=') ; ++noEcho ;
					bitshow() ;
				}
				else if(c == '~')	{	bittoggle() ;	}
				else				{	c = '?' ;		}
				break ;					 
			case 2 :
				if(c == 's')		{	kbm = 2 ;		}
				else if(c == 'p')	{	kbm = 1 ;		}
				else if(c == 'l')	{	kbm = 3 ;		}
				else if(c == 'i')	{	kbm = 6 ;		}
				else if(c == 'g')	{	gpsEcho = 1 ;	kbm = 9 ;		}
				else if(c == 'm')	{	gsmEcho = 1 ;	kbm = 10 ;		}
				else if(c == ' ')	{	}
				else if(c == '%')	{	while(1) ;		}
				else if(c == '0')	{	CCAPM1 = 0 ;	}
				else if(c == '1')	{	CCAPM1 = 0x42 ;	}
				else if(c == '+')	{	CCAP1H += 1 ;	}
				else if(c == '-')	{	CCAP1H -= 1 ;	}
				else if(c == '=')
				{
					putch('\r') ; putch('\n') ;
					putch('P')  ; putch('W') ;
					putch('=') ; ++noEcho ;
					putch('<') ;
					puthex(CCAP1H) ;
					putch('>') ;
				}
				else				{	c = '?' ;		}
				break ;
			case 3 :
				if(c == 'p')		{	kbm = 1 ;		}
				else if(c == 's')	{	kbm = 2 ;		}
				else if(c == 'l')	{	kbm = 3 ;		}
				else if(c == 'i')	{	kbm = 6 ;		}
				else if(c == 'g')	{	gpsEcho = 1 ; kbm = 9 ;		}
				else if(c == 'm')	{	gsmEcho = 1 ; kbm = 10 ;		}
				else if(c == ' ')	{	}
				else if(c == '%')	{	while(1) ;		}
				else if((c <= '9') && (c >= '0'))
				{
					p = b ;
					b = c - '0' ;
				}
				else if((c <= 'F') && (c >= 'A'))
				{
					p = b ;
					b = (c - 'A') + 10 ;
				}
				else if((c <= 'f') && (c >= 'a'))
				{
					p = b ;
					b = (c - 'a') + 10 ;
				}
				else if(c == 'r')
				{
					kbm = 4 ;
				}
				else if(c == 'w')
				{
					kbm = 5 ;
				}
				else				{	c = '?' ;	} 
				break ;
			case 4 :	/*	Read	*/
				if(c == '0')
				{
					++noEcho ;
					t = read_DSR() ;
					putch('0') ;
					putch('=') ;
					puthex(t) ;
					putch(' ');
				}
				else if(c == '1')
				{
					++noEcho ;
					t = read_DDR() ;
					putch('1') ;
					putch('=') ;
					puthex(t) ;
					putch(' ') ;
				}	
				else
				{
					c = '?' ;
				}
				kbm = 3 ;
				break ;
			case 5 :	/*	Write	*/
				if(c == '0')
				{
					t = (p << 4) + b ;
					write_DCR(t) ;
				}
				else if(c == '1')
				{
					t = (p << 4) + b ;
					write_DDR(t) ;
				}
				else
				{
					c = '?' ;
				}
				kbm = 3 ;
				break ;
			case 6 :
				if(c == 'p')		{	kbm = 1 ;		}
				else if(c == 's')	{	kbm = 2 ;		}
				else if(c == 'l')	{	kbm = 3 ;		}
				else if(c == 'i')	{	kbm = 6 ;		}
				else if(c == 'g')	{	gpsEcho = 1 ;	kbm = 9 ;	}
				else if(c == 'm')	{	gsmEcho = 1 ;	kbm = 10 ;	}
				else if(c == ' ')	{	}
				else if(c == '%')	{	while(1) ;		}
				else if((c <= '9') && (c >= '0'))
				{
					p = b ;
					b = c - '0' ;
				}
				else if((c <= 'F') && (c >= 'A'))
				{
					p = b ;
					b = (c - 'A') + 10 ;
				}
				else if((c <= 'f') && (c >= 'a'))
				{
					p = b ;
					b = (c - 'a') + 10 ;
				}
				else if(c == 'r')
				{
					kbm = 7 ;
				}
				else if(c == 'w')
				{
					kbm = 8 ;
				}
				else				{	c = '?' ;	} 
				break ;
			case 7 :
				if(c == '0')
				{
					++noEcho ;
					t = SPCON ;
					putch('0') ;
					putch('=') ;
					puthex(t) ;
					putch(' ');
				}
				else if(c == '1')
				{
					++noEcho ;
					t = SPDAT ;
					putch('1') ;
					putch('=') ;
					puthex(t) ;
					putch(' ') ;
				}
				else if(c == '2')
				{
					++noEcho ;
					t = SPSTA ;
					putch('2') ;
					putch('=') ;
					puthex(t) ;
					putch(' ') ;
				}	
				else
				{
					c = '?' ;
				}
				kbm = 6 ;
				break ;
			case 8 :
				if(c == '0')
				{
					t = (p << 4) + b ;
					SPCON = t ;
				}
				else if(c == '1')
				{
					t = (p << 4) + b ;
					SPDAT = t ;
				}
				else
				{
					c = '?' ;
				}
				kbm = 6 ;
				break ;
			case 9 :	/* Read characters from the GPS UART and send them out the serial port	*/
				if(c == 'p')		{	gsmEcho = 0 ; gpsEcho = 0 ; kbm = 1 ;		}
				else if(c == 's')	{	gsmEcho = 0 ; gpsEcho = 0 ; kbm = 2 ;		}
				else if(c == 'l')	{	gsmEcho = 0 ; gpsEcho = 0 ; kbm = 3 ;		}
				else if(c == 'i')	{	gsmEcho = 0 ; gpsEcho = 0 ; kbm = 6 ;		}
				else if(c == 'g')	{	gsmEcho = 0 ; gpsEcho = 1 ; kbm = 9 ;		}
				else if(c == 'm')	{	gsmEcho = 1 ; gpsEcho = 0 ; kbm = 10 ;	}
				else if(c == '1')	{	gps_sendDisableGGA() ; ++noEcho ;			}
				else if(c == '2')	{	gps_sendDisableGLL() ; ++noEcho ;			}
				else if(c == '3')	{	gps_sendDisableGSA() ; ++noEcho ;			}
				else if(c == '4')	{	gps_sendDisableGSV() ; ++noEcho ;			}
				else if(c == ' ')	{	}
				else if(c == '%')	{	while(1) ;		}
				break ;
			case 10 :
				if(c == '\x1B')		{	gsmEcho = 0 ; kbm = 0 ;		}
				
				
				
				/*	UART Write Command	*/
				++noEcho ;			/* Let the modem do the echoing	*/
				EX1 = 0 ;	/* Disable GPS Interrupts	*/
				EX0 = 0 ;

				GSMU_CS = 0 ;

				SPDAT = 0x80 ;			/* Send 1st byte of Transaction		*/
				while((SPSTA & 0x80) == 0) ;	/* Wait for completion				*/
				SPI_IN[0] = SPDAT ;				/* Read the Result					*/
				
				SPDAT = c ;				/* Send 2nd byte of Transaction		*/ 
				while((SPSTA & 0x80) == 0) ;	/* Wait for completion				*/
				SPI_IN[1] = SPDAT ;				/* Read the data character			*/
					
				GSMU_CS = 1 ;
								
				if(SPI_IN[0] & 0x80)	/* Valid Character	*/
				{
					if(gsm_nRx < 255)		/* Check to see if there is room		*/
					{
						gsm_RxBuffer[gsm_RxPut] = SPI_IN[1] ;
						++gsm_RxPut ;
						++gsm_nRx ;
					}
					else	/* One space remains	*/
					{
						gsm_RxBuffer[gsm_RxPut] = '%' ;		/* Put overrun character in buffer	*/
						}
				}
				else
				{
				}
				EX0 = 1 ;
				EX1 = 1 ;
				break ;
			default :
				kbm = 0 ;
				c = '!' ;
				break ;
		}	/* END switch(kbm)				*/
		if(noEcho)	;
		else		putch(c) ;	/* Echo the character	*/
	}		/* END Received character	*/
}