/*
**	sport.c
**  (c)Huron Net Works, Inc., 2005
**
**  Initialization Definition
**
**	9/6/05 --	Original
**
**  TABS 5, 9
**
*/
#include	"hardware.h"
#include	"externs.h"


void	sp_Init(void)
{
	sp_TxPut	= 0 ;	sp_RxPut	= 0 ;
	sp_TxGet	= 0 ;	sp_RxGet	= 0 ;
	sp_nTx		= 0 ;	sp_nRx		= 0 ;
}

void	sp_TxEnQueue(unsigned char c)
{
	ES =  0 ;	/* Disable Serial Interrupts	*/
	if(sp_nTx < 255)	/* Check to see if there is room	*/
	{
		sp_TxBuffer[sp_TxPut++]= c ;
		++sp_nTx ;
	}
	else
	{
		sp_TxBuffer[sp_TxPut] = '%' ;	/* The overrun character	*/
	}		
	{if(TDRE==1){TI=1;}}	/* Transmit Request Macro	*/
	ES = 1 ;
}

unsigned char	sp_RxDeQueue(void)
{
	if(sp_nRx > 0)	/* Check to see if there are any characters	*/
	{
		ES = 0 ;
		--sp_nRx ;
		B = sp_RxBuffer[sp_RxGet] ;
		sp_RxGet = (sp_RxGet + 1) & (SP_RX_SIZE - 1) ;
		ES = 1 ;
	}
	else
	{
		B = '\x80' ;
	}
	return B ;
}

interrupt [0x0023] using [2] void UART_int(void)
{
/*
**	ES = 0 ;	Disables the UART Interrupts
**	ES = 1 ;	Enables the UART Interrupts
**
**	This interrupt could be either the Receiver or the Transmitter
**	TDRE is a global bit which means a transmit interrupt occurred
**	and there were no more characters left to transmit.
*/
	if(RI == 1)	/* Receiver Interrupt Flag -- SBUF has the character			*/
	{
		RI = 0 ;				/* Clear the Receive Interrupt Flag				*/
		if(sp_nRx < SP_RX_SIZE)			/* Check to see if there is room				*/
		{
			if(FE == 1)			/* Check for Framing Errors						*/
			{					/* Ignore Framing Errors						*/
				FE = 0 ;		/* Clear the framing error bit					*/
				ACC = SBUF ;	/* Check for BREAK								*/
				if(ACC == 0)	BREAK = 1 ;
			}
			else
			{
				sp_RxBuffer[sp_RxPut] = SBUF ;
				sp_RxPut = (sp_RxPut + 1) & (SP_RX_SIZE - 1) ;
				++sp_nRx ;
			}
		}
		else	/* One space remains	*/
		{
			if(FE == 1)
			{
				FE = 0 ;		/* Clear the framing error bit					*/
				ACC = SBUF ;	/* Check for BREAK								*/
				if(ACC == 0)	BREAK = 1 ;
			}
			else
			{	/* Continue to overwrite the last character
				** Don't increment the pointer
				** Don't increment the count of characters in the queue
				*/
				sp_RxBuffer[sp_RxPut] = SBUF ;
			}
		}
	}
	if(TI == 1)	/* Transmitter is ready for the next character					*/
	{
		TI = 0 ;			/* Clear the Transmit Interrupt Flag				*/
		if(sp_nTx > 0)		/* Characters are ready to go						*/
		{
			TDRE = 0 ;		/* Transmitter is Busy								*/
			/*	In an 11-Bit Frame TB8 is the first of two STOP Bits			*/
			/*	In a 10-Bit Frame TB8 is a don't care							*/
			TB8 = 1 ;
			SBUF = sp_TxBuffer[sp_TxGet++] ;
			--sp_nTx ;
		}
		else			/* Transmitter is ready but we are out of characters	*/
		{	TDRE = 1 ;
		}
	}	
}
	